ComponentMetadata
Date: 2016-06-25

org.osgi.service.blueprint.reflect

## Interface ComponentMetadata

- All Superinterfaces:
    Metadata, NonNullMetadata
  All Known Subinterfaces:
    BeanMetadata, ReferenceListMetadata, ReferenceMetadata, ServiceMetadata, ServiceReferenceMetadata

      @ConsumerType
      public interface ComponentMetadata
      extends NonNullMetadata

  Metadata for managed components. This is the base type for `BeanMetadata`, `ServiceMetadata` and `ServiceReferenceMetadata`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ACTIVATION_EAGER` The component's manager must eagerly activate the component.
    `static int` | `ACTIVATION_LAZY` The component's manager must lazily activate the component.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getActivation()` Return the activation strategy for the component.
    `java.util.List<java.lang.String>` | `getDependsOn()` Return the ids of any components listed in a `depends-on` attribute for the component.
    `java.lang.String` | `getId()` Return the id of the component.

- - ### Field Detail

    - #### ACTIVATION_EAGER

          static final int ACTIVATION_EAGER

      The component's manager must eagerly activate the component.
      See Also:
        `getActivation()`, Constant Field Values

    - #### ACTIVATION_LAZY

          static final int ACTIVATION_LAZY

      The component's manager must lazily activate the component.
      See Also:
        `getActivation()`, Constant Field Values

  - ### Method Detail

    - #### getId

          java.lang.String getId()

      Return the id of the component.
      Returns:
        The id of the component. The component id can be `null` if this is an anonymously defined and/or inlined component.

    - #### getActivation

          int getActivation()

      Return the activation strategy for the component. This is specified by the `activation` attribute of a component definition. If this is not set, then the `default-activation` in the `blueprint` element is used. If that is also not set, then the activation strategy is `ACTIVATION_EAGER`.
      Returns:
        The activation strategy for the component.
      See Also:
        `ACTIVATION_EAGER`, `ACTIVATION_LAZY`

    - #### getDependsOn

          java.util.List<java.lang.String> getDependsOn()

      Return the ids of any components listed in a `depends-on` attribute for the component.
      Returns:
        An immutable List of component ids that are explicitly declared as a dependency, or an empty List if none.